// Vars
var q = "";
var url = ""
var space = "+"
if (window.widget) {
   widget.onhide = onhide;
   widget.onshow = onshow;
}

// Needed for validation
function isNumeric(val){return(parseFloat(val,10)==(val*1));}

function isInt (str)
{
        var i = parseInt (str);

        if (isNaN (i))
                return false;

        i = i . toString ();
        if (i != str)
                return false;

        return true;
}

function onshow () {
    // do something
}

function onhide () {
    // do something else
}

function find(q) {	
    // do something
    if (q == "")
    {
        clearSearch();
    }
    
    var q_array = q.split(" ");
    
    if (q.length == "5" && isNumeric (q))
    {
        url = "http://www.geocaching.com/seek/nearest.aspx?zip=" + q + "&x=0&y=0"
        widget.openURL(url)
    }
    else if ((q.charAt(0).toLowerCase() == "g") && (q.charAt(1).toLowerCase() == "c"))
    {
        url = "http://www.geocaching.com/seek/cache_details.aspx?wp=" + q
        widget.openURL(url)
    }
    else if ((q_array[0].charAt(0).toLowerCase() == "n") && (q_array[3].charAt(0).toLowerCase() == "w"))
    {
        url = "http://www.geocaching.com/seek/nearest.aspx?lat_ns=1&lat_h=" + q_array[1] + "&lat_mmss=" + q_array[2] + "&long_ew=-1&long_h=" + q_array[4] + "&long_mmss=" + q_array[5]
        widget.openURL(url)
    }
else if ((q_array[0].charAt(0).toLowerCase() == "t") && (q_array[0].charAt(1).toLowerCase() == "b"))
   {
      url = "http://www.geocaching.com/track/details.aspx?tracker=" + q
      widget.openURL(url)
}
    else
    {
        q = encodeURI(q.replace(/[\s]/gi, '+'));
        url = "http://www.geocaching.com/seek/nearest.aspx?key=" + q + "&submit4=Find"
        widget.openURL(url)
    }
}


//  Dashboard Code (from apple)
function setup() {
	createGenericButton(document.getElementById('done'), 'done', hidePrefs);
}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");
       
	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}